unit Latein3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin;

const AktiveSprache = 'L';

//type DeutscheArtikelType =
const DeutscheArtikel : array[1..10] of string = (
      ('der'),
      ('die'),
      ('das'),
      ('ein'),
      ('eine'),
      ('dem'),
      ('den'),
      ('einen'),
      ('einem'),
      ('einer')
      );

type
  TWort = record
    Sprache : char; //z.B. 'L', 'F', 'E'
    Lektion : integer;
    L : string[80];
    D : string[80];
    H : string[80];
    KoennenTemp : byte; //1-4; temporr
    KoennenZuletzt : byte; //1-4; bleibend
    Koennen : array[1..4] of word;
    //[1] : Anzahl Male beim 1. Mal richtig
    //[2] : Anzahl Male beim 2. Mal richtig
    //[3] : Anzahl Male beim 3. Mal richtig
    //[4] : Anzahl Male nicht gewusst
    EingabeDatum         : TDateTime; //Wort eingegeben am ...
    BetrachtungsDatum    : TDateTime; //Zuletzt betrachtet oder gebt(dann = UebeDatum) am ...
    UebeDatum            : TDateTime; //Zuletzt gebt am ...
    AufAnhiebDatum       : TDateTime; //Zuletzt auf Anhieb richtig am ...
    AufAnhieb1Tag        : TDateTime; //" .. innerhalb von 24 Stunden
    AufAnhieb7Tage       : TDateTime; //" .. innerhalb einer Woche
    AufAnhieb30Tage      : TDateTime; //" .. innerhalb eines Monates
    FalschDatum          : TDateTime; //Zuletzt falsch eingegeben am ...
    AnzEingegebenTemp    : integer; //(temporr) so oft wurde das Wort schon eingegeben
  end;
  LateinIni = record
    Lektion    : integer;
    LD         : boolean;
    AnzBed     : integer; //0 = oo
    KoennenAnz : boolean; //..anzeigen
    Musik      : boolean;
  end;

type
  TForm2 = class(TForm)
    ListBox1: TListBox;
    Label1: TLabel;
    LektionEdit: TSpinEdit;
    LateinEdit: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    DeutschEdit: TEdit;
    Neueswortbutton: TButton;
    Button1: TButton;
    Button2: TButton;
    procedure LateinEditKeyPress(Sender: TObject; var Key: Char);
    procedure DeutschEditKeyPress(Sender: TObject; var Key: Char);
    procedure NeueswortbuttonClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure LateinEditExit(Sender: TObject);
    procedure DeutschEditExit(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox1KeyPress(Sender: TObject; var Key: Char);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure LektionEditChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure LektionEditKeyPress(Sender: TObject; var Key: Char);
    procedure FormDeactivate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure ListeErneuern;
  end;

var
  Form2: TForm2;
  //ffentlich:
  f                 : file of TWort;
  Woerter           : array[0..100] of TWort;
  AnzWoerter        : integer;
  WoerterGeladen    : array[0..100] of TWort;
  AnzWoerterGeladen : integer;
  AktiveLektion     : integer;
  inidat            : LateinIni;
  f1                : file of LateinIni;


procedure LadeLektion(Nr : integer);
procedure SpeichereWoerter;
procedure SaveLateinIni;
procedure LoadLateinIni;

implementation

{$R *.DFM}

function WoerterGleich(w1, w2 : TWort) : boolean;
begin
  if (w1.L = w2.L) and (w1.D = w2.D) and (w1.H = w2.H) and (w1.Lektion = w2.Lektion) and (w1.Sprache = w2.Sprache) and
   (w1.KoennenTemp                 = w2.KoennenTemp) and
   (w1.KoennenZuletzt              = w2.KoennenZuletzt) and
   (w1.Koennen[1]                  = w2.Koennen[1]) and
   (w1.Koennen[2]                  = w2.Koennen[2]) and
   (w1.Koennen[3]                  = w2.Koennen[3]) and
   (w1.Koennen[4]                  = w2.Koennen[4]) and
   (w1.EingabeDatum                = w2.EingabeDatum) and
   (w1.BetrachtungsDatum           = w2.BetrachtungsDatum) and
   (w1.UebeDatum                   = w2.UebeDatum) and
   (w1.AufAnhiebDatum              = w2.AufAnhiebDatum) and
   (w1.AufAnhieb1Tag               = w2.AufAnhieb1Tag) and
   (w1.AufAnhieb7Tage              = w2.AufAnhieb7Tage) and
   (w1.AufAnhieb30Tage             = w2.AufAnhieb30Tage) and
   (w1.FalschDatum                 = w2.FalschDatum) and
   (w1.AnzEingegebenTemp           = w2.AnzEingegebenTemp) then

    result := true
  else
    result := false;
end;

procedure SaveLateinIni;
begin
  system.assign(f1, 'Latein2.ini');
  rewrite(f1);
  write(f1, inidat);
  close(f1);
end;

procedure LoadLateinIni;
begin
  {$i-}
  system.assign(f1, 'Latein2.ini');
  reset(f1);
  if IOResult = 0 then begin
    read(f1, inidat);
    close(f1);
  end else begin
    rewrite(f1);
    with inidat do begin
      Lektion    := 0;
      LD         := true;
      AnzBed     := 1;
      KoennenAnz := true;
      Musik      := true;
    end;
    close(f1);
  end;
  {$i+}
end;

procedure LadeLektion(Nr : integer);
begin
  //gewhlte Lektion einladen
  AnzWoerter := 0;
  seek(f, 0);
  while (not eof(f)) do begin
    read(f, Woerter[AnzWoerter]);
    if (Woerter[AnzWoerter].Sprache = AktiveSprache) and (Woerter[AnzWoerter].Lektion = Nr) then begin
      //Gefunden!
      inc(AnzWoerter);
    end;
  end;
  move(Woerter, WoerterGeladen, sizeof(Woerter));
  AnzWoerterGeladen := AnzWoerter;
end;

procedure SpeichereWoerter;
label Aufhoeren, Ueberspringen;
var i, y          : integer;
    Wort          : TWort;
    mussspeichern : boolean;
    Schreibpos    : longint;
    Altpos        : longint;
begin
  for i := 0 to AnzWoerter - 1 do begin
    for y := 0 to AnzWoerterGeladen - 1 do begin
      if woertergleich(Woerter[i], WoerterGeladen[y]) then begin
        Wort := Woerter[i];
        Woerter[i].L := ''; //Wort gilt als gelscht
        WoerterGeladen[y].L := '';
      end;
    end;
  end;
  y := 0;
  for i := 0 to AnzWoerter - 1 do begin
    Woerter[y] := Woerter[i];
    if Woerter[i].L <> '' then inc(y);
  end;
  AnzWoerter := y;
  y := 0;
  for i := 0 to AnzWoerterGeladen - 1 do begin
    WoerterGeladen[y] := WoerterGeladen[i];
    if WoerterGeladen[i].L <> '' then inc(y);
  end;
  AnzWoerterGeladen := y;
  //OK, nun sind die unvernderten Wrter entfernt.

  //Ganze Liste durschsuchen
  SchreibPos := 0;
  seek(f, 0);
  while (not eof(f)) do begin
    read(f, Wort);
    mussspeichern := false;
    if (Wort.Sprache = AktiveSprache) then begin
      for i := 0 to AnzWoerterGeladen - 1 do begin
        if woertergleich(WoerterGeladen[i], Wort) then begin
          //Ein altes Wort gefunden!
          //Mal schauen, was ich damit machen muss.
          for y := 0 to AnzWoerter - 1 do begin
            if woertergleich(Wort, Woerter[y]) then begin
              //Hmm...  Das kann gar nicht sein! Ich habe doch
              //vorher die doppelten entfernt!
              ShowMessage('Interner Programmierungsfehler in der Funktion SpeichereWoerter. Fehler: Doppelte Wrter mssten doch bereits entfernt sein!');
              goto Aufhoeren;
            end else if Wort.L = Woerter[y].L then begin
              //Wort ist nur im Lateinischen Teil gleich.
              //Ich muss also nur die Vernderung speichern.
              Wort := Woerter[y];
              Woerter[y].L := '';
              WoerterGeladen[i].L := '';
              mussspeichern := true;
              goto Aufhoeren;
            end;
          end;
          //Das Wort ist auf der neuen Liste nicht vorhanden.
          //Es muss gelscht werden. (konkret: nicht gespeichert)
          WoerterGeladen[i].L := '';
          goto Ueberspringen;
        end;
      end;
    end;
    Aufhoeren:
    if mussspeichern or (schreibpos <> filepos(f)) then begin
      altpos := filepos(f);
      seek(f, schreibpos);
      write(f, Wort);
      seek(f, altpos);
    end;
    inc(SchreibPos);
    Ueberspringen:
  end;
  seek(f, Schreibpos);
  //ab hier wird gnadenlos berschrieben
  for i := 0 to AnzWoerter - 1 do begin
    if Woerter[i].L <> '' then begin
      Wort := Woerter[i];
      write(f, Wort);
    end;
  end;
  truncate(f);//eventuellen Schrott abschneiden
  close(f); //sicherstellen
  reset(f);
  AnzWoerter := 0;
  AnzWoerterGeladen := 0;
end;

procedure TForm2.LateinEditKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then begin
    Key := #0;
    DeutschEdit.SetFocus;
  end;
end;

procedure TForm2.DeutschEditKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then begin
    Beep;
    Key := #0;
    LateinEdit.SetFocus;
    NeuesWortButton.Click;
  end;
end;

procedure TForm2.NeueswortbuttonClick(Sender: TObject);
begin
  LateinEdit.Text := '';
  DeutschEdit.Text := '';
  LateinEdit.SetFocus;
  ListBox1.ItemIndex := -1;
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
  Application.MessageBox('Bsp: "zusammenfhren, (ver)einigen" '+#13+#10+#13+#10+'Mehrere Bedeutungen knnen im deutschen Teil mit Komata getrennt werden, Dinge, die wegelassen werden drfen, sind in Klammern zu setzen.'+#13+#10+#13+#10+
              'Bsp: "regere, rego, rexi, rectum"'+#13+#10+#13+#10+'Im Fremdsprachigen Teil wird immer nur ein Wort beschrieben, Komata werden also ignoriert.'+#13+#10+#13+#10+
              'Artikel knnen im Deutschen weggelassen werden, auch beim ben.',
              'Hilfe', 1);
end;

procedure NeuesWort(_L, _D, _H : string);
var i    : integer;
    Now1 : TDateTime;
begin
  for i := 0 to Anzwoerter -1 do begin
    if Woerter[i].L = _L then begin
      Woerter[i].D := _D;
      Woerter[i].H := _H;
      exit;
    end;
  end;
  with Woerter[AnzWoerter] do begin
    Sprache := AktiveSprache;
    Lektion := Form2.LektionEdit.Value;
    L := _L;
    D := _D;
    H := _H;
    KoennenZuletzt := 4;
    KoennenTemp := 4;
    Koennen[1] := 0; //[1] : Anzahl Male beim 1. Mal richtig
    Koennen[2] := 0; //[2] : Anzahl Male beim 2. Mal richtig
    Koennen[3] := 0; //[3] : Anzahl Male beim 3. Mal richtig
    Koennen[4] := 0; //[4] : Anzahl Male nicht gewusst
    Now1 := Now;
    EingabeDatum         := Now1; //Wort eingegeben am ...
    BetrachtungsDatum    := Now1; //Zuletzt betrachtet oder gebt(dann = UebeDatum) am ...
    UebeDatum            := Now1; //Zuletzt gebt am ...
    AufAnhiebDatum       := Now1; //Zuletzt auf Anhieb richtig am ...
    AufAnhieb1Tag        := Now1; //" .. innerhalb von 24 Stunden
    AufAnhieb7Tage       := Now1; //" .. innerhalb einer Woche
    AufAnhieb30Tage      := Now1; //" .. innerhalb eines Monates
    FalschDatum          := Now1;
    AnzEingegebenTemp    := 0; 
  end;
  inc(AnzWoerter);
end;

procedure TForm2.ListeErneuern;
var i : integer;
begin
  ListBox1.Items.BeginUpdate;
  Listbox1.Items.Clear;
  for i := 0 to AnzWoerter - 1 do begin
    ListBox1.Items.Add(Woerter[i].L);
  end;
  ListBox1.Items.EndUpdate;
end;

procedure TForm2.LateinEditExit(Sender: TObject);
var i : integer;
begin
  //Wort abspeichern
  if LateinEdit.Text = '' then exit; //nix zu sichern
  if ListBox1.ItemIndex = -1 then begin
    //wenn kein Wort aktiv ist, dann
    NeuesWort(LateinEdit.Text, DeutschEdit.Text, '');
    ListeErneuern;
    ListBox1.ItemIndex := ListBox1.Items.IndexOf(LateinEdit.Text);
  end else begin
    //es ist schon was ausgewhlt. Lateinischer Teil verndern.
    for i := 0 to AnzWoerter - 1 do begin
      if Woerter[i].L = ListBox1.Items[ListBox1.ItemIndex] then begin
        if (i <> ListBox1.ItemIndex) and (ListBox1.Items.IndexOf(LateinEdit.Text) >= 0) then begin
          //FEHLER! Der Benutzer will den Lateinischen Text eines Wortes
          //in einen bereits vorhandenen ndern!
          //Was tun?!
          //Wort lschen!
          NeuesWortButton.Click;
        end else begin
          //alles OK.
          Woerter[i].L := LateinEdit.Text;
        end;
        ListeErneuern;
        ListBox1.ItemIndex := ListBox1.Items.IndexOf(LateinEdit.Text);
        exit;
      end;
    end;
  end;
end;

procedure TForm2.DeutschEditExit(Sender: TObject);
begin
  //Wort abspeichern
  if LateinEdit.Text = '' then exit; //nix zu sichern
  //wenn kein Wort aktiv ist, dann
  NeuesWort(LateinEdit.Text, DeutschEdit.Text, '');
  ListeErneuern;
  ListBox1.ItemIndex := ListBox1.Items.IndexOf(Lateinedit.Text);
end;

procedure TForm2.FormShow(Sender: TObject);
begin
  LadeLektion(LektionEdit.Value);
  ListeErneuern;
  LektionEdit.SetFocus;
  Lektionedit.Value := Inidat.Lektion;
  LoadLateinIni;
end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SpeichereWoerter;
end;

procedure TForm2.ListBox1Click(Sender: TObject);
begin
  if ListBox1.ItemIndex = -1 then exit;
  //ausgewhltes Wort aktivieren
  LateinEdit.Text := Woerter[ListBox1.ItemIndex].L;
  DeutschEdit.Text := Woerter[ListBox1.ItemIndex].D;
end;

procedure TForm2.ListBox1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #46 then begin
    messagebeep(1);
  end;
  if Key = #13 then LateinEdit.SetFocus;
end;

procedure TForm2.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i   : integer;
    alt : integer;
begin
  if Key = 46 then begin
    if ListBox1.ItemIndex = -1 then exit;
    alt := ListBox1.ItemIndex;
    for i := 0 to AnzWoerter - 1 do begin
      if ListBox1.Items[ListBox1.ItemIndex] = Woerter[i].L then begin
        for i := i to AnzWoerter - 2 do Woerter[i] := Woerter[i + 1];
        dec(AnzWoerter);
        ListeErneuern;
        ListBox1.ItemIndex := Alt;
        LateinEdit.Text := '';
        DeutschEdit.Text := '';
        exit;
      end;
    end;
  end;
end;

procedure TForm2.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #27 then begin
    Key := #0;
    Form2.Close;
  end;
  if (Key = #13) and LektionEdit.Focused then begin
    Key := #0;
    NeuesWortbutton.Click;
  end;
end;

procedure TForm2.LektionEditChange(Sender: TObject);
begin
  if Form2.Visible = false then exit;
  SpeichereWoerter;
  AktiveLektion := LektionEdit.Value;
  LadeLektion(AktiveLektion);
  ListeErneuern;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  LektionEdit.Value := 0;
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
  close;
end;

procedure TForm2.LektionEditKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then begin
    LateinEdit.SetFocus;
    Key := #0;
  end;
end;

procedure TForm2.FormDeactivate(Sender: TObject);
begin
  IniDat.Lektion := Lektionedit.Value;
  SaveLateinIni;
end;

end.
