unit Latein5;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Latein3, ExtCtrls;

type
  TForm4 = class(TForm)
    FrageLabel: TLabel;
    AntwortEdit: TEdit;
    OK: TButton;
    Shape1: TShape;
    Timer1: TTimer;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure AntwortEditKeyPress(Sender: TObject; var Key: Char);
    procedure OKClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    Wort : integer;
    AnzFalsch : integer;
    procedure NaechstesWort;
    function Richtig(Vorschlag : string) : boolean;
    procedure TimerGo;
  end;

var
  Form4: TForm4;
  Art  : byte;

implementation

uses Latein4, Latein9;

{$R *.DFM}

procedure TForm4.Button1Click(Sender: TObject);
begin
  Form7.ShowModal;
  OK.SetFocus;
  OK.Click;
end;

procedure TForm4.FormShow(Sender: TObject);
var i : integer;
begin
  OK.Visible := false;
  Button1.Visible := false;
  Shape1.Visible := IniDat.KoennenAnz;
  for i := 0 to AnzWoerter - 1 do begin
    case Art of
    1:Woerter[i].KoennenTemp := 2;
    2:;
    3:begin
      if Woerter[i].KoennenZuletzt > 1 then
        Woerter[i].KoennenTemp := 2
      else
        Woerter[i].KoennenTemp := 1;
    end;
    4:begin
      if (Woerter[i].Koennen[1] + Woerter[i].Koennen[2] + Woerter[i].Koennen[3] + Woerter[i].Koennen[4] < 2) or
         (Woerter[i].Koennen[1] + Woerter[i].Koennen[2] - Woerter[i].Koennen[3] - Woerter[i].Koennen[4] <= 0) then
        Woerter[i].KoennenTemp := 2
      else
        Woerter[i].KoennenTemp := 1;
    end;
    end;
    Woerter[i].AnzEingegebenTemp := 0;
  end;
  NaechstesWort;
end;

procedure TForm4.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #27 then close;
end;

procedure TForm4.NaechstesWort;
var i, y, yy, z : integer;
begin
  Shape1.Brush.Color := clBlack;
  y := 0;
  for i := 0 to AnzWoerter - 1 do begin
    if Woerter[i].KoennenTemp > 1 then inc(y);
  end;
  if y = 0 then begin
    //Keine weiteren Wrter mehr.
    ShowMessage('Keine weiteren Wrter');
    close;
    Timer1.Enabled := true; //falls nicht geschlossen werden konnte.
    exit;
  end;
  yy := y;
  for z := 1 to 20 do begin
    y := random(yy);
    for i := 0 to AnzWoerter - 1 do begin
      if Woerter[i].KoennenTemp > 1 then begin
        if y = 0 then break;
        dec(y);
      end;
    end;
    if Wort <> i then break;
  end;
  Wort := i;
  FrageLabel.caption := Woerter[Wort].L;
  AnzFalsch := 0;
  AntwortEdit.text := '';
end;

procedure TForm4.FormCreate(Sender: TObject);
begin
  Randomize;
end;

procedure SearchAndReplace(var s : string; Suchtxt, Replacetxt : string);
var p : integer;
begin
  while system.Pos(Suchtxt, s) > 0 do begin
    p := system.Pos(Suchtxt, s);
    delete(s, p, length(Suchtxt));
    insert(Replacetxt, s, p);
  end;
end;

{
function TForm4.Richtig(Vorschlag : string) : boolean;
label Nochmals1, Nochmals2;
var Richtig       : string;
    RichtigBAnz   : integer;
    RichtigB      : array[0..20] of string; //max. 20 Bedeutungn
    VorschlagBAnz : integer;
    VorschlagB    : array[0..20] of string; //max. 20 Bedeutungn
    pos, i, y     : integer;
begin
  if Length(Vorschlag) = 0 then begin
    Result := false;
    exit;
  end;
  if Form3.LD.Checked then begin
    //L -> D
    Richtig := Woerter[Wort].D;
    //1. Schritt: Alle berflssigen Leerzeichen lschen
    SearchAndReplace(Vorschlag, '  ', ' ');
    SearchAndReplace(Richtig  , '  ', ' ');
    //vielleicht waren's ja nur einige Leerschlge
    if Length(Vorschlag) <= 1 then begin
      Result := false;
      exit;
    end;
    //2. Schritt: alles kleinschreiben
    Vorschlag := AnsiLowerCase(Vorschlag);
    Richtig := AnsiLowerCase(Richtig);
    //2.5. Schritt: der, die, das, ein, einer, eine, einen... entfernen
    for i := Low(DeutscheArtikel) to High(DeutscheArtikel) do begin
      SearchAndReplace(Vorschlag, DeutscheArtikel[i] + ' ', '');
      SearchAndReplace(Richtig  , DeutscheArtikel[i] + ' ', '');
    end;
    SearchAndReplace(Vorschlag, '() ', '');
    SearchAndReplace(Richtig  , '() ', '');
    SearchAndReplace(Vorschlag, ' ()', '');
    SearchAndReplace(Richtig  , ' ()', '');
    //3. Schritt: die einzelnen Bedeutungen extrahieren
    VorschlagBAnz := 0;
    pos := 1;
    while pos <= length(Vorschlag) do begin
      //nchste durch Komata getrennte Bedeutung extrahieren
      VorschlagB[VorschlagBAnz] := '';
      while (pos <= length(Vorschlag)) and (Vorschlag[pos] <> ',') do begin
        VorschlagB[VorschlagBAnz] := VorschlagB[VorschlagBAnz] + Vorschlag[pos];
        inc(pos);
      end;
      if (pos <= length(Vorschlag)) and (Vorschlag[pos] = ',') then begin
        inc(pos);
        if Vorschlag[pos] = ' ' then inc(pos); //Leerschlag vergessen
      end;
      inc(VorschlagBAnz);
    end;
    RichtigBAnz := 0;
    pos := 1;
    while pos <= length(Richtig) do begin
      //nchste durch Komata getrennte Bedeutung extrahieren
      RichtigB[RichtigBAnz] := '';
      while (pos <= length(Richtig)) and (Richtig[pos] <> ',') do begin
        RichtigB[RichtigBAnz] := RichtigB[RichtigBAnz] + Richtig[pos];
        inc(pos);
      end;
      if (pos <= length(Richtig)) and (Richtig[pos] = ',') then begin
        inc(pos);
        if Richtig[pos] = ' ' then inc(pos); //Leerschlag vergessen
      end;
      inc(RichtigBAnz);
    end;
    //Durch Komata getrennte Bedeutungen sind nun in VorschlagB und in RichtigB auseinandergehalten.

    //Klammern werden nun in weitere Bedeutungen aufgelst.
    nochmals1:
    for i := 0 to VorschlagBAnz - 1 do begin
      if system.Pos('(', VorschlagB[i]) > 0 then begin
        if system.Pos(')', VorschlagB[i]) = 0 then begin
          showmessage('")" vergessen!');
          result := false;
          exit;
        end;
        VorschlagB[VorschlagBAnz] := VorschlagB[i];
        delete(VorschlagB[VorschlagBAnz], system.Pos('(', VorschlagB[VorschlagBAnz]), system.Pos(')', VorschlagB[VorschlagBAnz]) - system.Pos('(', VorschlagB[VorschlagBAnz]) + 1);

        delete(VorschlagB[i], system.Pos('(', VorschlagB[i]), 1);
        delete(VorschlagB[i], system.Pos(')', VorschlagB[i]), 1);

        inc(VorschlagBAnz);
        goto nochmals1;
      end;
    end;

    nochmals2:
    for i := 0 to RichtigBAnz - 1 do begin
      if system.Pos('(', RichtigB[i]) > 0 then begin
        if system.Pos(')', RichtigB[i]) = 0 then begin
          showmessage('")" vergessen!');
          result := false;
          exit;
        end;
        RichtigB[RichtigBAnz] := RichtigB[i];
        delete(RichtigB[RichtigBAnz], system.Pos('(', RichtigB[RichtigBAnz]), system.Pos(')', RichtigB[RichtigBAnz]) - system.Pos('(', RichtigB[RichtigBAnz]) + 1);

        delete(RichtigB[i], system.Pos('(', RichtigB[i]), 1);
        delete(RichtigB[i], system.Pos(')', RichtigB[i]), 1);

        inc(RichtigBAnz);
        goto nochmals2;
      end;
    end;

    //Leerschlge nochmals entfernen, diesmal aber auch am Anfang und am Schluss
    for i := 0 to VorschlagBAnz - 1 do begin
      SearchAndReplace(VorschlagB[i], '  ', ' ');
      y := length(VorschlagB[i]);
      while (y > 0) and (VorschlagB[i, 1] = ' ') do begin
        delete(VorschlagB[i], 1, 1);
        y := length(VorschlagB[i]);
      end;
      while (y > 0) and (VorschlagB[i, y] = ' ') do begin
        delete(VorschlagB[i], y, 1);
        y := length(VorschlagB[i]);
      end;
    end;

    for i := 0 to RichtigBAnz - 1 do begin
      SearchAndReplace(RichtigB[i], '  ', ' ');
      y := length(RichtigB[i]);
      while (y > 0) and (RichtigB[i, 1] = ' ') do begin
        delete(RichtigB[i], 1, 1);
        y := length(RichtigB[i]);
      end;
      while (y > 0) and (RichtigB[i, y] = ' ') do begin
        delete(RichtigB[i], y, 1);
        y := length(RichtigB[i]);
      end;
    end;

    //Nun muss von jeder eingegebenen Bedeutung berprft werden, ob sie richtig ist
    for i := 0 to VorschlagBAnz - 1 do begin
      pos := 0; //wird hier als Zhler der berreinstimmungen verwendet
      for y := 0 to RichtigBAnz - 1 do begin
        if VorschlagB[i] = RichtigB[y] then inc(pos);
      end;
      if pos = 0 then begin //FALSCH!
        //noch arbeitet hier eine knallharte Routiene.
        Result := false;
        exit;
      end;
    end;

    //... <-- Hier muss noch berprft werden, ob gengend Bedeutungen angegeben wurden.

    //wenn alles bis hier ausgefhrt wurde, na dann HERZLICHE GRATULATION!
    //Es ist RICHTIG!
    Result := true;
  end else begin
    //D -> L
    Result := Vorschlag = Woerter[Wort].L;
  end;
end;
}

procedure PrepareString(var s : string);
var
  y : integer;
begin
  //kleinschreiben
  s := AnsiLowerCase(s);
  //doppelte Leerschlge weg
  SearchAndReplace(s, '  ', ' ');
  //Leerschlge am Anfang und am Ende weg
  y := length(s);
  while (y > 0) and (s[1] = ' ') do begin
    delete(s, 1, 1);
    y := length(s);
  end;
  while (y > 0) and (s[y] = ' ') do begin
    delete(s, y, 1);
    y := length(s);
  end;
end;

type
  TVergleichWort = class
    private
    procedure Teilstring(s : string);
    public
    Auslegung : TStringList;
    constructor Create(s : string);
    destructor Destroy; override;
  end;

procedure TVergleichWort.Teilstring(s : string);
var
  v : TVergleichWort;
  i : integer;
begin
  v := TVergleichWort.Create(s);
  for i := 0 to v.Auslegung.Count-1 do begin
    Auslegung.Add(v.Auslegung.Strings[i]);
  end;
  v.Free;
end;

constructor TVergleichWort.Create(s : string);
var
  s1, s2 : string;
  p1, p2 : integer;
  i      : integer;
begin
  inherited Create;
  Auslegung := TStringList.Create;
  //Ziel: Das Problem in mindestens zwei Unterprobleme aufteilen
  if (Pos(',', s) > 0) or (Pos('/', s) > 0) then begin
    p1 := Pos(',', s); if p1 = 0 then p1 := Pos('/', s);

    s1 := s;
    s2 := s;

    delete(s1, p1, Length(s) - p1 + 1);
    delete(s2, 1, p1);

    Teilstring(s1);
    Teilstring(s2);
  end else if Pos('(', s) > 0 then begin
    p1 := Pos('(', s);
    p2 := Pos(')', s);

    s1 := s;
    s2 := s;

    if p2 > p1 then begin
      delete(s1, p1, p2 - p1 + 1);

      //Reihenfoge beachten!
      delete(s2, p2, 1);
      delete(s2, p1, 1);
    end else begin
      //) vergessen oder )( statt ()
      delete(s1, p1, length(s) - p1 + 1);

      delete(s2, p1, 1);
    end;
    Teilstring(s1);
    Teilstring(s2);
  end else begin
    //Klammern sind aufgelst.
    //Deutsche Artikel entfernen
    for i := Low(DeutscheArtikel) to High(DeutscheArtikel) do SearchAndReplace(s, DeutscheArtikel[i] + ' ', '');
    if s <> '' then begin
      //hmm, dann sind wir wohl am Ende!
      //nochmals doppelte Leerschlge weg, +Anfang und Ende
      PrepareString(s);
      Auslegung.Add(s);
    end; //else Nichts mehr brig!
  end;
end;

destructor TVergleichWort.Destroy;
begin
  Auslegung.Free;
  inherited Destroy;
end;

function TForm4.Richtig(Vorschlag : string) : boolean;
var
  Richtig1 : string;
  R, V    : TVergleichWort;
  i, j    : integer;
  b       : boolean;
begin
  Richtig1 := Woerter[Wort].D;
  if Richtig1 = Vorschlag then begin
    Result := true;
    exit;
  end;
  if Length(Vorschlag) = 0 then begin
    Result := false;
    exit;
  end;
  PrepareString(Richtig1);
  PrepareString(Vorschlag);
  R := TVergleichWort.Create(Richtig1);
  V := TVergleichWort.Create(Vorschlag);

  Result := true;
  for i := 0 to V.Auslegung.Count-1 do begin
    //alle Vorschlagsauslegungen mssen mit mindestens einer richtigen Auslegung bereinstimmen!
    b := false;
    for j := 0 to R.Auslegung.Count-1 do begin
      if V.Auslegung.Strings[i] = R.Auslegung.Strings[j] then begin
        b := true;
        break;
      end;
    end;
    if not b then begin
      Result := false;
      break;
    end;
  end;

  V.Free;
  R.Free;
end;

procedure TForm4.TimerGo;
begin
  if not inidat.KoennenAnz then exit;
  case Woerter[Wort].KoennenTemp of
  1: Shape1.Brush.Color := clGreen;
  2: Shape1.Brush.Color := clYellow;
  3: Shape1.Brush.Color := clRed;
  4: Shape1.Brush.Color := clRed;
  end;
end;

procedure TForm4.AntwortEditKeyPress(Sender: TObject; var Key: Char);
var now1 : TDateTime;
begin
  if Key = #13 then begin
    Key := #0;
    Now1 := Now;
    if Richtig(AntwortEdit.Text) then begin
      OK.Visible := true;
      Button1.Visible := true;
      OK.SetFocus;
      AntwortEdit.Text := Woerter[Wort].D;
      AntwortEdit.Enabled := false;
      if AnzFalsch = 0 then begin
        if Woerter[Wort].AnzEingegebenTemp = 0 then begin
          //Hey! Auf Anhieb richtig!
          with Woerter[Wort] do begin
            AufAnhiebDatum := now1;
            if now1 - AufAnhieb1Tag > 1 then AufAnhieb1Tag := now1;
            if now1 - AufAnhieb7Tage > 7 then AufAnhieb7Tage := now1;
            if now1 - AufAnhieb30Tage > 30 then AufAnhieb30Tage := now1;
          end;
        end else begin
          //Immerhin richtig.
        end;
        //Wie auch immer:
        if Woerter[Wort].KoennenTemp = 1 then runerror(255);
        dec(Woerter[Wort].KoennenTemp);
        Messagebeep(1);
      end else begin
        Woerter[Wort].FalschDatum := now1;
        //KoennenTemp nicht verndern
      end;
      inc(Woerter[Wort].Koennen[AnzFalsch + 1]);
      if Woerter[Wort].AnzEingegebenTemp = 0 then Woerter[Wort].KoennenZuletzt := AnzFalsch + 1;
      Woerter[Wort].BetrachtungsDatum := now1;
      Woerter[Wort].UebeDatum := now1;
      TimerGo;
    end else begin
      inc(AnzFalsch);
      if AnzFalsch = 3 then begin
        //beim 3. Mal falsch
        OK.Visible := true;
        Button1.Visible := true;
        OK.SetFocus;
        AntwortEdit.Text := Woerter[Wort].D;
        AntwortEdit.Enabled := false;
        Woerter[Wort].FalschDatum := now;
        inc(Woerter[Wort].Koennen[4]);
        if Woerter[Wort].AnzEingegebenTemp = 0 then Woerter[Wort].KoennenZuletzt := 4;
        //HIER wird die btiefe bestimmt: (4)
        if Woerter[Wort].KoennenTemp <     4 then inc(Woerter[Wort].KoennenTemp);

        Woerter[Wort].BetrachtungsDatum := now1;
        Woerter[Wort].UebeDatum := now1;
        TimerGo;
      end else begin
        //Neu versuchen!
        AntwortEdit.Text := '';
      end;
    end;
  end;
end;

procedure TForm4.OKClick(Sender: TObject);
begin
  inc(Woerter[Wort].AnzEingegebenTemp);
  AntwortEdit.Enabled := true;
  AntwortEdit.SetFocus;
  OK.Visible := false;
  Button1.Visible := false;
  Shape1.Brush.Color := clBlack;
  Timer1.Enabled := false;
  NaechstesWort;
end;

procedure TForm4.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := false;
  close;
end;

procedure TForm4.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SpeichereWoerter;
end;

end.
